
DEF VAR cReportcode      AS CHAR NO-UNDO.
DEF VAR cReportGroup     AS CHAR NO-UNDO.
DEF VAR cReportProcedure AS CHAR NO-UNDO.
DEF VAR iSeqnr           AS INT  NO-UNDO.
DEF VAR iJobnr           AS INT  NO-UNDO.



CLEAN_UP:
FOR EACH sp-report WHERE
         sp-report.applicationcode = "DP" AND
         sp-report.old_reportnr > 0
         EXCLUSIVE-LOCK:
  DELETE sp-report.
END.


TRANS_BLOCK:
DO TRANSACTION ON ERROR UNDO TRANS_BLOCK, LEAVE TRANS_BLOCK:
  report:
  FOR EACH dp-report NO-LOCK:
    
    cReportcode      = "".
    cReportGroup     = "".
    cReportProcedure = "".
    cReportGroup     = 'DP-' + dp-report.reportgroup.
    iSeqnr           = iSeqnr + 1.
    cReportcode     = dp-report.reportgroup + "-" + STRING(iSeqnr,"99").
    
    CREATE sp-report.
    ASSIGN sp-report.applicationcode     = "DP"
           sp-report.reportcode          = cReportcode
           sp-report.reportgroup         = cReportGroup
           sp-report.reporttype          = "CRYSTAL"
           sp-report.category            = cReportProcedure
           sp-report.reportname          = dp-report.reportname
           sp-report.dataobjectname      = dp-report.dataobjectname
           sp-report.viewerobjectname    = dp-report.viewerobjectname
           sp-report.des                 = dp-report.des
           sp-report.ordernr             = dp-report.ordernr
           sp-report.reportparameters    = dp-report.parameters
           sp-report.old_reportnr        = dp-report.reportnr
           .
  END.
END.

